<?php

namespace Spider\Src;

use Dever;
use Spider\Lib\Log;

class Data
{
	public function value($id)
	{
		$data = Dever::load('spider/data-one', $id);
		$data = json_decode($data['value'], true);
		$result = array();
		if (!$data) {
			return '';
		}
		foreach ($data as $k => $v) {
			$col = Dever::db('spider/col')->one(array('key' => $k));
			if ($col && $col['type'] < 3 && strlen($v) < 2000) {
				$result[$col['name'] . '('.$k.')'] = $v;
			}
		}
		$data['value'] = Dever::table($result);

		return $data['value'];
	}

	public function get($project_id = 1)
	{
		echo Dever::input('id');die;
		$data = Dever::load('spider/data-all', array('option_pid' => $project_id));

		return $data;
	}

	public function log($project_id = 1)
	{
		if (is_numeric($project_id)) {
			$log = new Log($project_id);
			$content = explode("\r\n", $log->get());

			return $content;
		}
	}

	# 清空数据
	public function drop()
	{
		$where['pid'] = Dever::input('id');
		Dever::db('spider/data')->delete($where);

		return 'reload';
	}

    # 清空数据
    public function use()
    {
        $where['option_pid'] = Dever::input('id');
        $where['set_use'] = 1;
        Dever::db('spider/data')->updates($where);

        return 'reload';
    }

	# 导出excel
    public function excel()
    {
    	$where['pid'] = Dever::input('id');
    	$data = Dever::db('spider/data')->select($where);
		
		if (!$data) {
			return '';
		}
		$col = Dever::db('spider/col')->select($where);
		$set = Dever::db('spider/set')->select($where);

		$info = Dever::db('spider/project')->find($where['pid']);
        $file = $info['name'] . '的采集数据';
        $header = $body = array();

        if ($col) {
        	foreach ($col as $k => $v) {
        		$header[] = $v['name'];
        	}
        }

        if ($set) {
        	foreach ($set as $k => $v) {
        		$header[] = $v['name'];
        	}
        }

        if ($data) {
        	$i = 0;
            foreach ($data as $k => $v) {

            	if (!$v['value']) {
            		continue;
            	}
            	$value = Dever::json_decode($v['value']);
            	if (!$value) {
            		continue;
            	}
                if ($col) {
		        	foreach ($col as $k => $v) {
		        		$body[$i][] = isset($value[$v['key']]) ? $value[$v['key']] : '';
		        	}
		        }

		        if ($set) {
		        	foreach ($set as $k => $v) {
		        		$body[$i][] = isset($value[$v['key']]) ? $value[$v['key']] : '';
		        	}
		        }

		        $i++;
            }
        }

        Dever::excelExport($body, $header, $file);
    }

    # 导出sql
    public function sql()
    {
    	$where['pid'] = Dever::input('id');
    	$data = Dever::db('spider/data')->select($where);
		
		if (!$data) {
			return '';
		}
		$col = Dever::db('spider/col')->select($where);
		$set = Dever::db('spider/set')->select($where);

		$info = Dever::db('spider/project')->find($where['pid']);
        $file = $info['name'] . '的采集数据';
        $header = $body = array();

        if ($col) {
        	foreach ($col as $k => $v) {
        		$header[] = '`' . $v['key'] . '`';
        	}
        }

        if ($set) {
        	foreach ($set as $k => $v) {
        		$header[] = '`' . $v['key'] . '`';
        	}
        }

        if ($data) {
        	$i = 0;
            foreach ($data as $k => $v) {

            	if (!$v['value']) {
            		continue;
            	}
            	$value = Dever::json_decode($v['value']);
            	if (!$value) {
            		continue;
            	}
                if ($col) {
		        	foreach ($col as $k => $v) {
		        		$body[$i][] = isset($value[$v['key']]) ? $value[$v['key']] : '';
		        	}
		        }

		        if ($set) {
		        	foreach ($set as $k => $v) {
		        		$body[$i][] = isset($value[$v['key']]) ? $value[$v['key']] : '';
		        	}
		        }

		        $i++;
            }
        }

        $col = implode(',', $header);
        $sql = $this->createInsertSql('data', $col, $body);

        $file = Dever::data() . 'data.sql';
        if (is_file($file)) {
        	unlink($file);
        }
        file_put_contents($file, $sql);

        $file = Dever::upload($file);

        return Dever::location($file);
    }

    public function createInsertSql($table, $col, $value)
    {
        $sql = 'INSERT INTO `' . $table . '` (' . $col . ') VALUES ';

        $max = count($value) - 1;

        foreach ($value as $k => $v) {
        	$v = implode('\',\'', $v);
            $sql .= '(\'' . $v . '\')';

            if ($k >= $max) {
                $sql .= '';
            } else {
                $sql .= ',';
            }
        }

        return $sql;
    }
}
